
#include "coast.hpp"


// Constructors:
CoastIterationStatement::CoastIterationStatement()
{
	this->init       = NULL;
	this->condition  = NULL;
	this->increment  = NULL;
	this->statements = new CoastStatementCollection();
}//CoastIterationStatement
CoastIterationStatement::CoastIterationStatement( CoastStatement* init, CoastExpression* condition, CoastStatement* increment )
{
	this->init       = init;
	this->condition  = condition;
	this->increment  = increment;
	this->statements = new CoastStatementCollection();
}//CoastIterationStatement
CoastIterationStatement::CoastIterationStatement( CoastStatement* init, CoastExpression* condition, CoastStatement* increment, CoastStatementCollection* statements )
{
	this->init       = init;
	this->condition  = condition;
	this->increment  = increment;
	this->statements = statements;
}//CoastIterationStatement





// Destructor:
CoastIterationStatement::~CoastIterationStatement()
{
	if ( this->init != NULL )
		delete this->init;

	if ( this->condition != NULL )
		delete this->condition;

	if ( this->increment != NULL )
		delete this->increment;

	delete this->statements;

}//~CoastIterationStatement

