
#include "coast.hpp"


// Constructors:
CoastSwitchStatement::CoastSwitchStatement()
{
	this->exclusive      = false;
	this->expression     = NULL;
	this->case_options   = new CoastSwitchCaseOptionCollection();
	this->default_option = NULL;
}//CoastSwitchStatement
CoastSwitchStatement::CoastSwitchStatement( CoastExpression* expression )
{
	this->exclusive      = false;
	this->expression     = expression;
	this->case_options   = new CoastSwitchCaseOptionCollection();
	this->default_option = NULL;
}//CoastSwitchStatement
CoastSwitchStatement::CoastSwitchStatement( CoastExpression* expression, bool exclusive )
{
	this->exclusive      = exclusive;
	this->expression     = expression;
	this->case_options   = new CoastSwitchCaseOptionCollection();
	this->default_option = NULL;
}//CoastSwitchStatement





// Destructor:
CoastSwitchStatement::~CoastSwitchStatement()
{
	if ( this->expression != NULL )
		delete this->expression;

	if ( this->case_options != NULL )
		delete this->case_options;

	if ( this->default_option != NULL )
		delete this->default_option;

}//~CoastSwitchStatement

