
#ifndef _C_CODE_PROVIDER_H_
#define _C_CODE_PROVIDER_H_


#include "coast.hpp"
//#include <string>
//#include <list>

using namespace std;





/*
    CCodeProvider

    C language code provider.
    (Gabriele Budelacci, 2003-02-08)
*/
class CCodeProvider : public CoastProvider
{
public:

	// compile_assembly:
	//	Compile assembly fom the specified source.
	virtual bool compile_assembly( CoastElement *ast );

	// generate_code:
	//	Generate source code from the specified source.
	virtual string generate_code( CoastElement *ast );

protected:

	// get_assembly:
	//	Get the assembly code of a element.
	virtual string get_assembly( CoastApplication*                   application );
	virtual string get_assembly( CoastArgumentDeclarationExpression* expression  );
	virtual string get_assembly( CoastArgumentReferenceExpression*   expression  );
	virtual string get_assembly( CoastArrayIndexerExpression*        expression  );
	virtual string get_assembly( CoastAssignStatement*               statement   );
	virtual string get_assembly( CoastBinaryOperatorExpression*      expression  );
	virtual string get_assembly( CoastBreakStatement*                statement   );
	virtual string get_assembly( CoastCommentStatement*              statement   );
	virtual string get_assembly( CoastConditionStatement*            statement   );
	virtual string get_assembly( CoastContinueStatement*             statement   );
	virtual string get_assembly( CoastEntryPointFunction*            function    );
	virtual string get_assembly( CoastElement*                       element     );
	virtual string get_assembly( CoastExpressionStatement*           statement   );
	virtual string get_assembly( CoastFunction*                      function    );
	virtual string get_assembly( CoastFunctionInvokeExpression*      expression  );
	virtual string get_assembly( CoastIterationStatement*            statement   );
	virtual string get_assembly( CoastPrimitiveExpression*           expression  );
	virtual string get_assembly( CoastReturnStatement*               statement   );
	virtual string get_assembly( CoastSnippetExpression*             expression  );
	virtual string get_assembly( CoastSnippetMember*                 member      );
	virtual string get_assembly( CoastSnippetStatement*              statement   );
	virtual string get_assembly( CoastSwitchCaseOption*              option      );
	virtual string get_assembly( CoastSwitchDefaultOption*           option      );
	virtual string get_assembly( CoastSwitchStatement*               statement   );
	virtual string get_assembly( CoastTypeReference*                 reference   );
	virtual string get_assembly( CoastUnaryOperatorExpression*       expression  );
	virtual string get_assembly( CoastVariableDeclarationStatement*  statement   );
	virtual string get_assembly( CoastVariableReferenceExpression*   expression  );

};//CoastCodeProvider





#endif

